/*
 *  JFrameSpectrum.java
 *  Version 1beta0
 *  Created on January 29, 2002, 1:31 PM
 *  @author  Marco Parvis
 */

/*
    Questo e' JFrameSpectrum una parte di Instrument Training Project ITP
    Copyright (C) <Politecnico di Torino 2002> <Marco Parvis>
 
    This is JFrameSpectrum part of the Instrument Training Project ITP
    Copyright (C) <Politecnico di Torino 2002> <Marco Parvis>
 
 */

/*
    Questo  programma e'  software  libero; e'  lecito redistribuirlo  o
    modificarlo secondo i termini  della Licenza Pubblica Generica GNU
    come e' pubblicata dalla Free  Software Foundation; o la versione 2
    della licenza o (a propria scelta) una versione successiva.
 
    Questo programma  e' distribuito nella  speranza che sia  utile, ma
    SENZA  ALCUNA GARANZIA;  senza  neppure la  garanzia implicita  di
    NEGOZIABILITA'  o di  APPLICABILITA' PER  UN PARTICOLARE  SCOPO.  Si
    veda la Licenza Pubblica Generica GNU per avere maggiori dettagli.
 
    Questo  programma deve  essere  distribuito assieme  ad una  copia
    della Licenza Pubblica Generica GNU;  in caso contrario, se ne puo'
    ottenere  una scrivendo  alla Free  Software Foundation,  Inc., 59
    Temple Place, Suite 330, Boston, MA 02111-1307 USA
 
    L'autore puo' essere contattato a parvis@polito.it
    Dipartimento di Elettronica Politecnico di Torino
    Corso Duca degli Abruzzi, 24, 10129 Torino Italy
 */

/*
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of the
    License, or (at your option) any later version.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    General Public License for more details.
 
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
    02111-1307 USA
 
    The author can be contacted at parvis@polito.it
    Dipartimento di Elettronica Politecnico di Torino
    Corso Duca degli Abruzzi, 24, 10129 Torino Italy
 
 */

/*
 * This panel provides a simple spectrum analyzer
 */





package JavaScope;
import javax.swing.*;
import java.awt.*;
import java.util.*;
import java.io.*;
import java.text.*;







/**
 *
 * @author  admsermis
 */
public class JFrameSpectrum extends javax.swing.JFrame implements VirtualPanel{ // Observer{
    
    private final int RECT=0;
    private final int HANNING=1;
    private final int HAMMING=2;
    private final int NYQUIST_FREQ=22050;
    private final int MIN_SPAN=100;
    private int windowType=RECT;
    private boolean acCoupling=false;
    private boolean recompute=true;
    private boolean zoomRequested=true;
    private String panelIdString;
    private boolean useCalibrationFactor=false;
    private double calFactorVoltAtBitCh1=1;
    private double calFactorVoltAtBitCh2=1;
    private String lastSaveDir="";
    
    
    private boolean weAreInABench=false;
    private InputManager man;
    private final int MAX_FFT_LEN=8192;
    private int FFT_LEN=512;
    private int N_DECADES=3;
    
    private float[] averValues=new float[MAX_FFT_LEN];
    private int averNum=1;
    private int averAvail=0;
    
    //private float[] fftMag=new float[MAX_FFT_LEN];
    private int channel=0;
    private float[] inputData=new float[MAX_FFT_LEN];
    private Fourier fManager=new Fourier();
    private int w = 10; //last computed plot screen width
    private int h = 10; //last computed plot screen height;
    private int[] xScreen=new int[MAX_FFT_LEN];    //x positions on plot screen
    private int[] yChannel1=new int[MAX_FFT_LEN];  //scaled channels
    private int[] yChannel2=new int[MAX_FFT_LEN];
    private float[] window;
    
    private double startFreq=0,stopFreq=NYQUIST_FREQ;
    private long newUpdate=0;
    private boolean doNotListen=false;
    
    private short[] dataS;
    
    
    
    
    /** Creates new form jFrameSpectrum */
    
    
    public JFrameSpectrum() {
        
        initComponents();
        this.jComboBoxNPoints.addItem(" 512");
        this.jComboBoxNPoints.addItem("1024");
        this.jComboBoxNPoints.addItem("2048");
        this.jComboBoxNPoints.addItem("4096");
        this.jComboBoxNPoints.addItem("8192");
        this.jComboBoxNPoints.setSelectedIndex(3);
        
        this.jComboBoxYScale.addItem("40");
        this.jComboBoxYScale.addItem("60");
        this.jComboBoxYScale.addItem("80");
        this.jComboBoxYScale.addItem("100");
        this.jComboBoxYScale.addItem("120");
        this.jComboBoxYScale.setSelectedIndex(3);
        
        this.jComboBoxInput.addItem("CH 1");
        this.jComboBoxInput.addItem("CH 2");
        this.jComboBoxInput.setSelectedIndex(0);
        
        //this.jComboBoxNPoints.setSelectedIndex(1);
        
        
        this.jComboBoxAverage.addItem("1");
        this.jComboBoxAverage.addItem("2");
        this.jComboBoxAverage.addItem("4");
        this.jComboBoxAverage.addItem("8");
        this.jComboBoxAverage.addItem("16");
        this.jComboBoxAverage.addItem("32");
        this.jComboBoxAverage.addItem("64");
        this.jComboBoxAverage.addItem("128");
        this.jComboBoxAverage.addItem("256");
        this.jComboBoxAverage.setSelectedIndex(0);
        
        //this.jComboBoxYScale.setSelectedIndex(0);
        
        this.jComboBoxWindow.addItem("none");
        this.jComboBoxWindow.addItem("hanning");
        this.jComboBoxWindow.addItem("hamming");
        this.jComboBoxWindow.setSelectedIndex(HANNING);
        
        weAreInABench=false;
        //        man=new InputManager();
        //        man.addObserver(this);
        window=Fourier.hanning(FFT_LEN);
        this.jCheckBoxAutoScale.setVisible(false);
    }
    public JFrameSpectrum(InputManager im) {
        initComponents();
        this.jComboBoxNPoints.addItem(" 512");
        this.jComboBoxNPoints.addItem("1024");
        this.jComboBoxNPoints.addItem("2048");
        this.jComboBoxNPoints.addItem("4096");
        this.jComboBoxNPoints.addItem("8192");
        this.jComboBoxNPoints.setSelectedIndex(3);
        
        this.jComboBoxYScale.addItem("40");
        this.jComboBoxYScale.addItem("60");
        this.jComboBoxYScale.addItem("80");
        this.jComboBoxYScale.addItem("100");
        this.jComboBoxYScale.addItem("120");
        this.jComboBoxYScale.setSelectedIndex(3);
        
        this.jComboBoxInput.addItem("CH 1");
        this.jComboBoxInput.addItem("CH 2");
        this.jComboBoxInput.setSelectedIndex(0);
        
        //this.jComboBoxNPoints.setSelectedIndex(1);
        
        
        this.jComboBoxAverage.addItem("1");
        this.jComboBoxAverage.addItem("2");
        this.jComboBoxAverage.addItem("4");
        this.jComboBoxAverage.addItem("8");
        this.jComboBoxAverage.addItem("16");
        this.jComboBoxAverage.addItem("32");
        this.jComboBoxAverage.addItem("64");
        this.jComboBoxAverage.addItem("128");
        this.jComboBoxAverage.addItem("256");
        this.jComboBoxAverage.setSelectedIndex(0);
        
        //this.jComboBoxYScale.setSelectedIndex(0);
        
        this.jComboBoxWindow.addItem("none");
        this.jComboBoxWindow.addItem("hanning");
        this.jComboBoxWindow.addItem("hamming");
        this.jComboBoxWindow.setSelectedIndex(HANNING);
        //this.jComboBoxNPoints.setSelectedIndex(1);
        weAreInABench=true;
        //       this.man=im;
        //       man.addObserver(this);
        window=Fourier.hanning(FFT_LEN);
        this.jCheckBoxAutoScale.setVisible(false);
        
    }
    
    public void useOutputCalibration(boolean use){
    }
    public void useInputCalibration(boolean use){
        this.useCalibrationFactor=use;
    }
    public void setOutputCalibration(double newCalCh1,double newCalCh2){
    }
    public void setInputCalibration(double newCalCh1,double newCalCh2){
        this.calFactorVoltAtBitCh1=newCalCh1;
        this.calFactorVoltAtBitCh2=newCalCh2;
    }
    
    
    
    
    
    public String getSettings(){
        int x=this.getLocation().x;
        int y=this.getLocation().y;
        int w=this.getSize().width;
        int h=this.getSize().height;
        
        String s=panelIdString+"|Position="+String.valueOf(x)+","+String.valueOf(y)+"|Size="+String.valueOf(w)+","+String.valueOf(h)+"|";
        if (this.useCalibrationFactor)
            s=s+"UseInputCal=1|";
        else
            s=s+"UseInputCal=0|";
        s=s+"InputCalFactors="+String.valueOf(this.calFactorVoltAtBitCh1)+","+String.valueOf(this.calFactorVoltAtBitCh2);
        s=s+"|LastDir="+this.lastSaveDir;
        return s;
    }
    public void applySettings(String settings){
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        StringTokenizer tokens=new StringTokenizer(settings,"|");
        while (tokens.hasMoreTokens()){
            String token=tokens.nextToken();
            //browse through recognized tokens
            if (token.indexOf("Position=")>=0){
                String[] p=getValues(token);
                try{
                    int x=new Integer(p[0]).intValue();
                    int y=new Integer(p[1]).intValue();
                    if (x<1) x=1;
                    if (x>screenSize.width-10) x=screenSize.width-10;
                    if (y<1) y=1;
                    if (y>screenSize.height-10) y=screenSize.height-10;
                    this.setLocation(x,y);
                }catch (Throwable t){}
                
            }else if (token.indexOf("Size=")>=0){
                String[] p=getValues(token);
                try{
                    int x=new Integer(p[0]).intValue();
                    int y=new Integer(p[1]).intValue();
                    if (x<10) x=10;
                    if (x>screenSize.width-20) x=screenSize.width-20;
                    if (y<10) y=10;
                    if (y>screenSize.height-20) y=screenSize.height-20;
                    this.setSize(x,y);
                }catch (Throwable t){}
            }else if (token.indexOf("UseInputCal=")>=0){
                String[] p=getValues(token);
                try{
                    int x=new Integer(p[0]).intValue();
                    if (x!=0)
                        this.useCalibrationFactor=true;
                    else
                        this.useCalibrationFactor=false;
                }catch (Throwable t){}
            }else if (token.indexOf("InputCalFactors=")>=0){
                String[] p=getValues(token);
                try{
                    double x=new Double(p[0]).doubleValue();
                    double y=new  Double(p[1]).doubleValue();
                    this.calFactorVoltAtBitCh1=x;
                    this.calFactorVoltAtBitCh2=y;
                }catch (Throwable t){}
                
            }else if (token.indexOf("LastDir=")>=0){
                String[] p=getValues(token);
                try{
                    this.lastSaveDir=p[0];
                }catch (Throwable t){}
            }
        }
        
    }
    private String[] getValues(String s){
        int peq=s.indexOf("=");
        if (peq>0){
            StringTokenizer ss=new StringTokenizer(s.substring(peq+1),",");
            if (ss.countTokens()>0){
                String[] vl=new String[ss.countTokens()];
                for (int i=0;i<vl.length;i++)
                    vl[i]=ss.nextToken();
                return vl;
            }else
                return new String[0];
            
        }else
            return new String[0];
    }
    public void setOutputManager(OutputManager im){
    }
    public void setInputManager(InputManager im){
        this.man=im;
        man.addObserver(this);
    }
    public void setBenchComponent(boolean bc){
        weAreInABench=bc;
        if (bc)
            this.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
        else
            this.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
        
    }
    public void setIdString(String s){
        this.panelIdString=s;
        this.setTitle(s);
    }
    public String getIdString(){
        return this.panelIdString;
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        jPopupMenuZoom = new javax.swing.JPopupMenu();
        jPanelBase = new javax.swing.JPanel();
        jPanelSpectrum = new SpectrumScreen();
        jPanelSpectrumCommands = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jComboBoxNPoints = new javax.swing.JComboBox();
        jLabel2 = new javax.swing.JLabel();
        jComboBoxYScale = new javax.swing.JComboBox();
        jCheckBoxAutoScale = new javax.swing.JCheckBox();
        jLabel3 = new javax.swing.JLabel();
        jComboBoxInput = new javax.swing.JComboBox();
        jLabel4 = new javax.swing.JLabel();
        jComboBoxAverage = new javax.swing.JComboBox();
        jLabel5 = new javax.swing.JLabel();
        jComboBoxWindow = new javax.swing.JComboBox();
        jTextFieldCenter = new javax.swing.JTextField();
        jLabelCenter = new javax.swing.JLabel();
        jLabelSpan = new javax.swing.JLabel();
        jTextFieldSpan = new javax.swing.JTextField();
        jButtonSetCenter = new javax.swing.JButton();
        jButtonFullScale = new javax.swing.JButton();
        jCheckBoxAC = new javax.swing.JCheckBox();
        jToolBarSpectrum = new javax.swing.JToolBar();
        jButtonSaveTrace = new javax.swing.JButton();

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        jPanelBase.setLayout(null);

        jPanelBase.setBackground(java.awt.Color.red);
        jPanelBase.addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentResized(java.awt.event.ComponentEvent evt) {
                jPanelBaseComponentResized(evt);
            }
        });

        jPanelSpectrum.setBorder(new javax.swing.border.EtchedBorder());
        jPanelSpectrum.setMinimumSize(new java.awt.Dimension(20, 20));
        jPanelSpectrum.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanelSpectrum.addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentMoved(java.awt.event.ComponentEvent evt) {
                jPanelSpectrumComponentMoved(evt);
            }
        });
        jPanelSpectrum.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jPanelSpectrumMouseClicked(evt);
            }
            public void mouseEntered(java.awt.event.MouseEvent evt) {
                jPanelSpectrumMouseEntered(evt);
            }
            public void mouseExited(java.awt.event.MouseEvent evt) {
                jPanelSpectrumMouseExited(evt);
            }
        });
        jPanelSpectrum.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
            public void mouseMoved(java.awt.event.MouseEvent evt) {
                jPanelSpectrumMouseMoved(evt);
            }
        });

        jPanelBase.add(jPanelSpectrum);
        jPanelSpectrum.setBounds(200, 10, 320, 190);

        jPanelSpectrumCommands.setLayout(new java.awt.GridBagLayout());

        jPanelSpectrumCommands.setBorder(new javax.swing.border.EtchedBorder());
        jLabel1.setText("Points");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 0);
        jPanelSpectrumCommands.add(jLabel1, gridBagConstraints);

        jComboBoxNPoints.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBoxNPointsActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.ipadx = 20;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHEAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 5);
        jPanelSpectrumCommands.add(jComboBoxNPoints, gridBagConstraints);

        jLabel2.setText("Y Scale");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 0);
        jPanelSpectrumCommands.add(jLabel2, gridBagConstraints);

        jComboBoxYScale.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBoxYScaleActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHEAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 5);
        jPanelSpectrumCommands.add(jComboBoxYScale, gridBagConstraints);

        jCheckBoxAutoScale.setText("AutoScale");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTH;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 5);
        jPanelSpectrumCommands.add(jCheckBoxAutoScale, gridBagConstraints);

        jLabel3.setText("Input");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 0);
        jPanelSpectrumCommands.add(jLabel3, gridBagConstraints);

        jComboBoxInput.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBoxInputActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHEAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 5);
        jPanelSpectrumCommands.add(jComboBoxInput, gridBagConstraints);

        jLabel4.setText("Aver.");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 0);
        jPanelSpectrumCommands.add(jLabel4, gridBagConstraints);

        jComboBoxAverage.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBoxAverageActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 5);
        jPanelSpectrumCommands.add(jComboBoxAverage, gridBagConstraints);

        jLabel5.setText("Window");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 0);
        jPanelSpectrumCommands.add(jLabel5, gridBagConstraints);

        jComboBoxWindow.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBoxWindowActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 5);
        jPanelSpectrumCommands.add(jComboBoxWindow, gridBagConstraints);

        jTextFieldCenter.setText("11050");
        jTextFieldCenter.setToolTipText("display center freq");
        jTextFieldCenter.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextFieldCenterActionPerformed(evt);
            }
        });
        jTextFieldCenter.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                jTextFieldCenterKeyPressed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 20;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 5);
        jPanelSpectrumCommands.add(jTextFieldCenter, gridBagConstraints);

        jLabelCenter.setText("Center");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 0);
        jPanelSpectrumCommands.add(jLabelCenter, gridBagConstraints);

        jLabelSpan.setText("Span");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 0);
        jPanelSpectrumCommands.add(jLabelSpan, gridBagConstraints);

        jTextFieldSpan.setText("22100");
        jTextFieldSpan.setToolTipText("display total span");
        jTextFieldSpan.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                jTextFieldSpanKeyPressed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 40;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 5);
        jPanelSpectrumCommands.add(jTextFieldSpan, gridBagConstraints);

        jButtonSetCenter.setText("Set");
        jButtonSetCenter.setToolTipText("set selected span and center");
        jButtonSetCenter.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonSetCenterActionPerformed(evt);
            }
        });
        jButtonSetCenter.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButtonSetCenterMouseClicked(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 5);
        jPanelSpectrumCommands.add(jButtonSetCenter, gridBagConstraints);

        jButtonFullScale.setText("Full Span");
        jButtonFullScale.setToolTipText("reset to full span");
        jButtonFullScale.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonFullScaleActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.gridwidth = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        jPanelSpectrumCommands.add(jButtonFullScale, gridBagConstraints);

        jCheckBoxAC.setText("AC coupling");
        jCheckBoxAC.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxACActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 9;
        gridBagConstraints.gridwidth = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanelSpectrumCommands.add(jCheckBoxAC, gridBagConstraints);

        jPanelBase.add(jPanelSpectrumCommands);
        jPanelSpectrumCommands.setBounds(10, 10, 170, 310);

        getContentPane().add(jPanelBase, java.awt.BorderLayout.CENTER);

        jButtonSaveTrace.setIcon(new javax.swing.ImageIcon(getClass().getResource("/JavaScope/resources/save.gif")));
        jButtonSaveTrace.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jButtonSaveTrace.setMinimumSize(new java.awt.Dimension(20, 24));
        jButtonSaveTrace.setPreferredSize(new java.awt.Dimension(20, 24));
        jToolBarSpectrum.add(jButtonSaveTrace);

        getContentPane().add(jToolBarSpectrum, java.awt.BorderLayout.NORTH);

        pack();
    }//GEN-END:initComponents
    
    private void jPanelSpectrumMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jPanelSpectrumMouseClicked
        int bt=evt.getButton();
        if (bt==evt.BUTTON3 | bt==evt.BUTTON2){
            int pCenter=evt.getX();
            int centerFreq=((SpectrumScreen)this.jPanelSpectrum).decodeXPoint(pCenter);
            System.out.println(centerFreq);
            this.jPopupMenuZoom.add("aaa");
        }
    }//GEN-LAST:event_jPanelSpectrumMouseClicked
    
    private void jCheckBoxACActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxACActionPerformed
        if (this.jCheckBoxAC.isSelected())
            acCoupling=true;
        else
            acCoupling=false;
        recompute=true;
    }//GEN-LAST:event_jCheckBoxACActionPerformed
    
    private void jPanelSpectrumMouseEntered(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jPanelSpectrumMouseEntered
        ((SpectrumScreen)this.jPanelSpectrum).showCoord(true);
    }//GEN-LAST:event_jPanelSpectrumMouseEntered
    
    private void jPanelSpectrumMouseExited(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jPanelSpectrumMouseExited
        ((SpectrumScreen)this.jPanelSpectrum).showCoord(false);
    }//GEN-LAST:event_jPanelSpectrumMouseExited
    
    private void jPanelSpectrumMouseMoved(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jPanelSpectrumMouseMoved
        Point p=evt.getPoint();
        //System.out.println(p.x+"   "+p.y);
        ((SpectrumScreen)this.jPanelSpectrum).setCoord(p);
        
    }//GEN-LAST:event_jPanelSpectrumMouseMoved
    
    private void jButtonFullScaleActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonFullScaleActionPerformed
        this.jTextFieldCenter.setBackground(Color.white);
        this.jTextFieldSpan.setBackground(Color.white);
        startFreq=0;
        stopFreq=NYQUIST_FREQ;
        this.jTextFieldSpan.setText(new Integer((int)startFreq).toString());
        this.jTextFieldCenter.setText(new Integer((int)stopFreq).toString());
        zoomRequested=true;
        
    }//GEN-LAST:event_jButtonFullScaleActionPerformed
    
    private void jButtonSetCenterMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButtonSetCenterMouseClicked
        this.jTextFieldCenter.setBackground(Color.white);
        this.jTextFieldSpan.setBackground(Color.white);
        //now check for consistency
        //give more importance to the span
        double reqSpan=parseAndValidate(this.jTextFieldSpan, 11025);
        double reqCenter=parseAndValidate(this.jTextFieldCenter, NYQUIST_FREQ);
        if (reqSpan>NYQUIST_FREQ)
            reqSpan=NYQUIST_FREQ;
        if (reqSpan<MIN_SPAN)
            reqSpan=MIN_SPAN;
        if (reqCenter<MIN_SPAN/2)
            reqCenter=MIN_SPAN/2;
        if (reqCenter>NYQUIST_FREQ-MIN_SPAN/2)
            reqCenter=NYQUIST_FREQ-MIN_SPAN/2;
        if ((reqCenter-reqSpan/2)<0)
            reqCenter=reqSpan/2;
        if ((reqCenter+reqSpan/2)>NYQUIST_FREQ)
            reqCenter=NYQUIST_FREQ-reqSpan/2;
        //now set values
        this.jTextFieldSpan.setText(new Integer((int)reqSpan).toString());
        this.jTextFieldCenter.setText(new Integer((int)reqCenter).toString());
        
        startFreq=reqCenter-reqSpan/2;
        stopFreq=reqCenter+reqSpan/2;
        zoomRequested=true;
        // Add your handling code here:
    }//GEN-LAST:event_jButtonSetCenterMouseClicked
    
    private void jButtonSetCenterActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonSetCenterActionPerformed
        // Add your handling code here:
    }//GEN-LAST:event_jButtonSetCenterActionPerformed
    
    private void jTextFieldSpanKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextFieldSpanKeyPressed
        this.jTextFieldSpan.setBackground(Color.yellow);
        
        // Add your handling code here:
    }//GEN-LAST:event_jTextFieldSpanKeyPressed
    
    private void jTextFieldCenterKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextFieldCenterKeyPressed
        this.jTextFieldCenter.setBackground(Color.yellow);
        
        // Add your handling code here:
    }//GEN-LAST:event_jTextFieldCenterKeyPressed
    
    private void jTextFieldCenterActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextFieldCenterActionPerformed
        // Add your handling code here:
    }//GEN-LAST:event_jTextFieldCenterActionPerformed
    
    private void jComboBoxWindowActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBoxWindowActionPerformed
        int id=this.jComboBoxWindow.getSelectedIndex();
        windowType=id;
        recompute=true;
    }//GEN-LAST:event_jComboBoxWindowActionPerformed
    
    private void jComboBoxInputActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBoxInputActionPerformed
        int id=this.jComboBoxInput.getSelectedIndex();
        if (id==0)
            channel=0;
        else
            channel=1;
        averAvail=0;
    }//GEN-LAST:event_jComboBoxInputActionPerformed
    
    private void jComboBoxAverageActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBoxAverageActionPerformed
        int id=this.jComboBoxAverage.getSelectedIndex();
        String s=this.jComboBoxAverage.getSelectedItem().toString().trim();
        //System.out.println("S: "+s);
        try{
            averNum=
            Integer.valueOf(s).intValue();
        }
        catch (NumberFormatException ne) {
            System.out.println(ne.toString());
            averNum=1;
        }
        averAvail=0;
    }//GEN-LAST:event_jComboBoxAverageActionPerformed
    
    private void jComboBoxYScaleActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBoxYScaleActionPerformed
        int id=this.jComboBoxYScale.getSelectedIndex();
        String s=this.jComboBoxYScale.getSelectedItem().toString().trim();
        //System.out.println("S: "+s);
        try{
            N_DECADES=
            Integer.valueOf(s).intValue()/20;
        }
        catch (NumberFormatException ne) {
            System.out.println(ne.toString());
            N_DECADES=3;
        }
    }//GEN-LAST:event_jComboBoxYScaleActionPerformed
    
    private void jComboBoxNPointsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBoxNPointsActionPerformed
        int id=this.jComboBoxNPoints.getSelectedIndex();
        String s=this.jComboBoxNPoints.getSelectedItem().toString().trim();
        //System.out.println("S: "+s);
        try{
            FFT_LEN=
            Integer.valueOf(s).intValue();
        }
        catch (NumberFormatException ne) {
            System.out.println(ne.toString());
            FFT_LEN=512;
            
        }
        
    }//GEN-LAST:event_jComboBoxNPointsActionPerformed
    
    private void jPanelBaseComponentResized(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_jPanelBaseComponentResized
        Dimension panelSize=this.jPanelBase.getSize();
        //maintain the left panel at fixed X size
        this.jPanelSpectrumCommands.setLocation(0,0);
        Dimension commandSize=this.jPanelSpectrumCommands.getSize();
        this.jPanelSpectrumCommands.setSize(commandSize.width,panelSize.height);
        this.jPanelSpectrum.setLocation(commandSize.width+1,0);
        this.jPanelSpectrum.setSize(panelSize.width-commandSize.width-2,panelSize.height);
        
        
        
        
        
    }//GEN-LAST:event_jPanelBaseComponentResized
    
    private void jPanelSpectrumComponentMoved(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_jPanelSpectrumComponentMoved
        // Add your handling code here:
    }//GEN-LAST:event_jPanelSpectrumComponentMoved
    
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        if (!weAreInABench){
            if (this.man!=null)
                this.man.stopCapture();
            System.exit(0);
        }
        else{
            int n = JOptionPane.showConfirmDialog(
            this,
            "This panel has been created by a bench manager. \n It should not be manually destroyed \n Are you SURE you want to continue?",
            "Alert",
            JOptionPane.YES_NO_OPTION,JOptionPane.WARNING_MESSAGE);
            if (n==JOptionPane.YES_OPTION){
                man.deleteObserver(this);
                this.dispose();}
            
            
        }
        
    }//GEN-LAST:event_exitForm
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        new JFrameSpectrum().show();
    }
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonFullScale;
    private javax.swing.JButton jButtonSaveTrace;
    private javax.swing.JButton jButtonSetCenter;
    private javax.swing.JCheckBox jCheckBoxAC;
    private javax.swing.JCheckBox jCheckBoxAutoScale;
    private javax.swing.JComboBox jComboBoxAverage;
    private javax.swing.JComboBox jComboBoxInput;
    private javax.swing.JComboBox jComboBoxNPoints;
    private javax.swing.JComboBox jComboBoxWindow;
    private javax.swing.JComboBox jComboBoxYScale;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabelCenter;
    private javax.swing.JLabel jLabelSpan;
    private javax.swing.JPanel jPanelBase;
    private javax.swing.JPanel jPanelSpectrum;
    private javax.swing.JPanel jPanelSpectrumCommands;
    private javax.swing.JPopupMenu jPopupMenuZoom;
    private javax.swing.JTextField jTextFieldCenter;
    private javax.swing.JTextField jTextFieldSpan;
    private javax.swing.JToolBar jToolBarSpectrum;
    // End of variables declaration//GEN-END:variables
    
    public void update(Observable o, Object arg){
        //new data arrived arg is  short[] and contains the samples in sequence
        short[] dataS=(short[])arg;
        long now=System.currentTimeMillis();
        
        if (doNotListen){
            //           System.out.println("Busy !!! "+System.currentTimeMillis());
            return;}
        if ((now<newUpdate)){
            //           System.out.println("Waiting "+System.currentTimeMillis());
            return;}
        
        doNotListen=true;
        if(inputData.length!=FFT_LEN | recompute){
            recompute=false;
            inputData=new float[FFT_LEN];
            switch (windowType){
                case RECT:
                    window=Fourier.rect(FFT_LEN);
                    break;
                case HANNING:
                    window=Fourier.hanning(FFT_LEN);
                    break;
                case HAMMING:
                    window=Fourier.hanning(FFT_LEN);
                    break;
            }
            averValues=new float[FFT_LEN];
            averAvail=0;
        }
        try{
            double s=0.0;
            
            if (acCoupling){
                for (int i=0;i<FFT_LEN;i++){
                    s+=dataS[channel+2*i];
                }
                s/=FFT_LEN;
            }
            
            for (int i=0;i<FFT_LEN;i++){
                inputData[i]=(float)(((double)dataS[channel+2*i]-s)*window[i]);
            }
            fManager.FFTMag(inputData);
            computeSamples(inputData);
            
            jPanelSpectrum.repaint();
        }
        catch(Throwable t){}
    }
    
    private boolean computeSamples(float[] dataS){
        
        
        //divide the space in .1 .8 .1
        int central=(int)(0.9*h);
        int up=(h-central)/2;
        int down = h-central-up;
        float maxD=(float)-1e10,minD=(float)1e10;
        double scale=central/(N_DECADES*Math.log(10));
        
        ((SpectrumScreen)this.jPanelSpectrum).setYscale(scale,up);
        if (averNum==1){
            for (int x = 0; x < FFT_LEN/2; x++) {
                if (dataS[x]>maxD)
                    maxD=dataS[x];
                else if (dataS[x]<minD)
                    minD=dataS[x];
            }
            double maxLog=Math.ceil(Math.log((double)maxD)/Math.log(10));
            for (int x = 0; x < FFT_LEN/2; x++) {
                if (dataS[x]>0)
                    yChannel1[x]=up-(int)(scale*(Math.log(dataS[x]/maxD)));
                else{
                    //System.out.println("zero:"+x);
                    yChannel1[x]=h; //up-(int)(scale*3);
                }
            }
        }else{
            if (averAvail<averNum)
                averAvail++;
            
            float scaleNew=(float)(1.0/averAvail);
            float scaleOld=(float)((averAvail-1.0)/averAvail);
            for (int x = 0; x < FFT_LEN/2; x++) {
                averValues[x]=averValues[x]*scaleOld+dataS[x]*scaleNew;
            }
            for (int x = 0; x < FFT_LEN/2; x++) {
                if (averValues[x]>maxD)
                    maxD=averValues[x];
                else if (averValues[x]<minD)
                    minD=averValues[x];
            }
            double maxLog=Math.ceil(Math.log((double)maxD)/Math.log(10));
            
            for (int x = 0; x < FFT_LEN/2; x++) {
                if (averValues[x]>0)
                    yChannel1[x]=up-(int)(scale*(Math.log(averValues[x]/maxD)));
                else
                    yChannel1[x]=h;
            }
            
        }
        
        /*
        try {
            PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter("d:\\javameas\\datis.txt")));
            for (int i=0;i<FFT_LEN/2;i++){
                out.println(yChannel1[i]);
         
            }
            out.close();}
        catch (IOException ie){
            System.out.println(ie.toString());
        }
         */
        
        
        
        return true;
        
        
        
        
        
    }
    private double parseAndValidate(JTextField v, double defValue){
        String st="";
        
        try{
            DecimalFormat df2 =
            (DecimalFormat)NumberFormat.getInstance();
            st=v.getText();
            Number n= df2.parse(st);
            return n.doubleValue();
        }
        catch(Throwable t){
            System.out.println("String "+st+" is not a correct number for this locale !");
            return defValue;
        }
    }
    
    
    class SpectrumScreen extends JPanel {
        private final int XPOS=20;
        private final int YPOS=20;
        double xScale=1;
        double yScale=1,yOffset=0;
        
        int startSample=0;
        int stopSample=128;
        
        private Point lastP=new Point(0,0);
        private boolean showC=false;
        public SpectrumScreen() {
            setBackground(new Color(20, 20, 20));
        }
        public int decodeXPoint(int x){
            double freqRes=(double)NYQUIST_FREQ/(FFT_LEN/2);
            
            double sNum=x/xScale+startSample;
            return (int)(sNum*freqRes);
            
            
            
        }
        public void setYscale(double s,int o){
            this.yScale=s;
            this.yOffset=(double)o;
        }
        public void showCoord(boolean b){
            this.showC=b;
        }
        
        public void setCoord(Point p){
            lastP=p;
        }
        public void paint(Graphics g) {
            int i=0;
            
            double expX=1;
            super.paint(g);
            Dimension d = getSize();
            int wn = d.width;
            int hn = d.height;
            
            double freqRes=(double)NYQUIST_FREQ/(FFT_LEN/2);
            startSample=(int)(startFreq/freqRes);
            stopSample=(int)(stopFreq/freqRes);
            //            System.out.println("res:"+freqRes+"  freq:"+stopFreq+"  start:"+startSample+"  stop:"+stopSample+"  fft len:"+FFT_LEN);
            
            if (wn!=w | hn!=h | FFT_LEN!=xScreen.length | zoomRequested){
                //the screen size has changed throw the  data
                zoomRequested=false;
                w=wn;
                h=hn;
                int sampleNum=stopSample-startSample;
                xScale=(double)w/sampleNum;
                xScreen=new int[FFT_LEN];
                for (int j=0;j<FFT_LEN;j++)
                    //xScreen[j]=(int)(w*j/(FFT_LEN/2));
                    xScreen[j]=(int)(1+xScale*(j-startSample));
            }
            
            Graphics2D g2 = (Graphics2D) g;
            g2.setBackground(getBackground());
            g2.clearRect(0, 0, w, h);
            doGrid(g2); //    //draw the grid
            //plot the traces
            g2.setColor(Color.yellow);
            if (showC){
                //compute actual cursor position
                DecimalFormat df2 =
                (DecimalFormat)NumberFormat.getInstance();
                //X
                df2.applyPattern("###00.0");
                double sNum=lastP.x/xScale+startSample;
                double cFreq=sNum*freqRes;
                String value=new String(df2.format(cFreq));
                String s="Cursor at: "+value+" Hz";
                //Y
                //yChannel1[x]=up-(int)(scale*(Math.log(dataS[x]/maxD)));
                double yp=(yOffset-lastP.y)/yScale*20/Math.log(10);
                df2.applyPattern("#000.0");
                
                value=new String(df2.format(yp));
                s=s+" "+value+ "dB";
                
                
                g2.drawString(s,XPOS,YPOS);
            }
            long sp=System.currentTimeMillis();
            //    for (i = 1; i < FFT_LEN/2; i++) {
            for (i = startSample+1; i < stopSample; i++) {
                g.drawLine(xScreen[(i-1)], yChannel1[i-1],
                xScreen[i],yChannel1[i]);
            }
            long en=System.currentTimeMillis();
            long du=en-sp;
            newUpdate=en+2*du;
            doNotListen=false;
            
            //       System.out.println("Paint at "+sp+" dur:"+du);
            
        }
        
        private void doMessage(Graphics2D g2){
            g2.drawString("ciao",10,10);
        }
        private void doGrid(Graphics2D g2){
            int i=0;
            //do the main grid
            int central=(int)(0.9*h);
            int up=(h-central)/2;
            int down = h-central-up;
            
            
            //do the vertical grid
            g2.setColor(Color.lightGray);
            for (i=0;i<=N_DECADES;i++)
                g2.drawLine(0,(int)(up+central*i/(N_DECADES)),w, (int)(up+central*i/(N_DECADES)));
            //do the horizontal grid every 2 kHz
            float xsc=(float)((20000.0/22100.0)*w/10.0);
            for (i=1;i<=10;i++)
                g2.drawLine((int)(xsc*i),up,(int)(xsc*i),up+central);
            
        }
    } // End class ScopeScreen
    
    
    
}
