/*
 *  SettingManager.java
 *  Created on January 29, 2002, 1:31 PM
 *  @version 1beta0
 *  @author  Marco Parvis
 */

/*    
    Questo e' SettingManager una parte di Instrument Training Project ITP
    Copyright (C) <Politecnico di Torino 2002> <Marco Parvis>
    
    This is SettingManager part of the Instrument Training Project ITP
    Copyright (C) <Politecnico di Torino 2002> <Marco Parvis>

*/

/*
    Questo  programma e'  software  libero; e'  lecito redistribuirlo  o
    modificarlo secondo i termini  della Licenza Pubblica Generica GNU
    come e' pubblicata dalla Free  Software Foundation; o la versione 2
    della licenza o (a propria scelta) una versione successiva.

    Questo programma  e' distribuito nella  speranza che sia  utile, ma
    SENZA  ALCUNA GARANZIA;  senza  neppure la  garanzia implicita  di
    NEGOZIABILITA'  o di  APPLICABILITA' PER  UN PARTICOLARE  SCOPO.  Si
    veda la Licenza Pubblica Generica GNU per avere maggiori dettagli.

    Questo  programma deve  essere  distribuito assieme  ad una  copia
    della Licenza Pubblica Generica GNU;  in caso contrario, se ne puo'
    ottenere  una scrivendo  alla Free  Software Foundation,  Inc., 59
    Temple Place, Suite 330, Boston, MA 02111-1307 USA

    L'autore puo' essere contattato a parvis@polito.it 
    Dipartimento di Elettronica Politecnico di Torino
    Corso Duca degli Abruzzi, 24, 10129 Torino Italy
*/

/*
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
    02111-1307 USA

    The author can be contacted at parvis@polito.it 
    Dipartimento di Elettronica Politecnico di Torino
    Corso Duca degli Abruzzi, 24, 10129 Torino Italy

*/


/*
 * This class provides a unified way to deal with settings
 */

package JavaScope;

import java.io.*;
//import javax.swing.*;
//import java.lang.Object.*;
//import java.awt.*;
import java.util.*;
//import java.util.Enumeration;
//import java.io.*;

public class SettingManager extends java.lang.Object {
    Vector settings = new Vector();
    String filename=new String(" ");
    
    /** Creates new SettingManager */
    
    public SettingManager(String filename){
        this.filename=filename;
        openFile(filename);
    }
    public String getSettings(String title){
        for (int i=0;i<settings.size();i++){
            String sb=(String)(settings.get(i));
            
            if (sb.indexOf(title)>=0){
                return sb;
            }
        }
        return "";
    }
    
    public void updateSettings(String sb){
        int npos=sb.indexOf("|"); //get the first token
        
        String name=sb.substring(0,npos);
        
        for (int i=0;i<settings.size();i++){
            String actSb= (String)(settings.get(i));
            if (actSb.indexOf(name)>=0){
                settings.removeElementAt(i);
                break;
            }
        }
        settings.add(sb);
    }
    public void saveSettings()  {
        // Use unbuffered streams, because we're going to use a large buffer
        // for this sequential io.
        try {
            PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter(filename)));
            for (int i=0;i<settings.size();i++){
                out.println((String)settings.get(i));
                
            }
            out.close();}
            catch (IOException ie){
                System.out.println(ie.toString());
            }
    }
    
    private boolean openFile(String filename) {
        // Use unbuffered streams, because we're going to use a large buffer
        // for this sequential io.
        String tmpStr;
        BufferedReader in;
        try {
            in
            = new BufferedReader(new InputStreamReader(new FileInputStream(filename)));
        } catch (FileNotFoundException fe){
            //file does notexist
            settings.removeAllElements();
            return false;
        } catch (Throwable ie){ //catch (IOException ie){
            System.out.println(ie.toString());
            return false;
        }
        try {
            settings.removeAllElements();
            while ((tmpStr=in.readLine())!=null){
                if (tmpStr.length()>0){
                       settings.add(tmpStr);
                }
            }
            in.close();
            return true;
            
        }
        catch (Throwable ie){ //catch (IOException ie){
            System.out.println(ie.toString());}
        return false;
    }
    
    
}
